<script lang="ts">
import { defineComponent } from 'vue'

export default defineComponent({
  props: {
    text: String,
    isUser: Boolean,
  },
})
</script>

<template>
  <div
    class="message"
    :class="{ 'user-message': isUser }"
  >
    <div
      v-if="isUser"
      class="avatar"
    >
      <img
        src="@images/avatars/avatar-1.png"
        class="avatar"
        alt="User"
      >
    </div>

    <div
      v-else
      class="video-avatar avatar"
    >
      <video
        playsinline
        autoplay
        loop
        muted
        class="avatar-video "
      >
        <source
          src="@/assets/videos/ai-avatar.webm"
          type="video/webm"
        >
        <!-- Poster image as fallback if the video fails to load -->
        <img
          src="@images/avatars/ai-avatar-fallback.png"
          alt="Bot"
        >
      </video>
    </div>
    <div
      class="text-bubble"
      :class="{ 'user-text': isUser }"
    >
      <span
        v-for="(line, index) in text.split('\n')"
        :key="index"
        class="message-line"
      >{{ line }}</span>
    </div>
  </div>
</template>

<style scoped>
.message {
  display: flex;
  align-items: center;
  margin-bottom: 10px;
}

.user-message {
  flex-direction: row-reverse;
}

.avatar {
  width: 45px;
  height: 45px;
  border-radius: 50%;
  margin: 0 10px;
}

.avatar-video {
  width: 100%;
  height: 100%;
  object-fit: cover;
  transform: scale(1.4) translateY(5px);
}

.video-avatar {
  width: 50px;
  height: 50px;
  border-radius: 50%;
  overflow: hidden;
  margin: 0 10px;
  border: 2px solid white;
  position: relative;
}

.text-bubble {
  max-width: 70%;
  padding: 10px;
  border-radius: 15px;
  background-color: #e5e5ea; /* Light gray for bot messages */
  margin: 5px;
  word-wrap: break-word;
}

.user-text {
  background-color: #c6e5f8; /* Light green for user messages */
}

.message-line {
  display: block; /* Asegura que cada línea sea un bloque y aparezca en una nueva línea */
}
</style>
